//+------------------------------------------------------------------+
//|                                                            2.mq5 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 31
#property indicator_plots   31
//--- plot Label1
#property indicator_label1  "Label1"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- input parameters
input int   MinPeriod=10;
input int   Step=3;
input int   Count=40;
//--- indicator buffers
double         Label1Buffer[];

struct SBuf{
   double buf[]; 
   double k1,k2;
};
SBuf buf[30];

double col[];

double v[30];
double d[29];
double s[29];

int mn[29],mx[29];
int mnCnt,mxCnt;
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(){
//--- indicator buffers mapping
   int i=0;
   for(;i<30;i++){
      SetIndexBuffer(i,buf[i].buf,INDICATOR_DATA);
      PlotIndexSetInteger(i,PLOT_DRAW_TYPE,DRAW_LINE);
      PlotIndexSetInteger(i,PLOT_LINE_STYLE,STYLE_SOLID);
      PlotIndexSetInteger(i,PLOT_LINE_COLOR,clrRed);
      int per=MinPeriod+i*Step;
      PlotIndexSetString(i,PLOT_LABEL,"MA("+IntegerToString(per)+")");
      buf[i].k1=2.0/(per+1.0);
      buf[i].k2=1.0-buf[i].k1;
   }
   
   SetIndexBuffer(i,col,INDICATOR_DATA);
   PlotIndexSetInteger(i,PLOT_DRAW_TYPE,DRAW_LINE);
   PlotIndexSetInteger(i,PLOT_LINE_STYLE,STYLE_SOLID);
   PlotIndexSetInteger(i,PLOT_LINE_COLOR,clrYellow);   
   PlotIndexSetInteger(i,PLOT_LINE_WIDTH,2);      
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

   int start;
   
   if(prev_calculated==0){
      start=1;
      for(int i=0;i<30;i++){
         buf[i].buf[0]=close[0];
      }      
   }
   else{
      start=prev_calculated-1;
   }
   
   for(int i=start;i<rates_total;i++){
      
      col[i]=EMPTY_VALUE;
      
      for(int j=0;j<30;j++){
         buf[j].buf[i]=close[i]*buf[j].k1+buf[j].buf[i-1]*buf[j].k2;
         v[j]=buf[j].buf[i];
      }      
      
      ArraySort(v);
      for(int k=0;k<29;k++){
         d[k]=v[k+1]-v[k];
      }
    
      SmoothArray(d,s,7);
      
      FindMinMax(s,mx,mxCnt,mn,mnCnt);
      
      
      for(int k=0;k<30;k++){
         string n=MQLInfoString(MQL_PROGRAM_NAME)+"_"+time[i]+"_"+k;
         if(ObjectFind(0,n)==-1)break;
         ObjectDelete(0,n);
      }
      
      if(mnCnt>0){
         for(int k=0;k<mnCnt;k++){
           // col[i]=v[mn[k]];
            Line(MQLInfoString(MQL_PROGRAM_NAME)+"_"+time[i]+"_"+k,time[i],v[mn[k]]);
         }
         //}
      }
   }

   ChartRedraw();

   return(rates_total);
  }
//+------------------------------------------------------------------+


void Line(string name,datetime time,double v){
   ObjectCreate(0,name,OBJ_TREND,0,0,0);
   ObjectMove(0,name,0,time,v);
   ObjectMove(0,name,1,time/*-PeriodSeconds()*/,v);
   ObjectSetInteger(0,name,OBJPROP_WIDTH,3);
   ObjectSetInteger(0,name,OBJPROP_COLOR,clrYellow);   
      
}

void FindMinMax(double & a[],int & mx[],int & mxCnt,int & mn[],int & mnCnt){

   mxCnt=0;
   mnCnt=0;

   int size=ArraySize(a);
   int dir=0;
   int i=1;
   for(;i<size;i++){
      if(a[i]>a[i-1]){
         dir=1;
         
         //mn[mnCnt]=0;
         //mnCnt++;         
         
         break;
      }
      else if(a[i]<a[i-1]){
         dir=-1;
         
         mx[mxCnt]=0;
         mxCnt++;           
         
         break;
      }
   }
   i++;
   for(;i<size;i++){
      if(dir==-1 && a[i]>a[i-1]){
         mn[mnCnt]=i-1;
         mnCnt++;
         dir=1;
      }
      else if( dir==1 && a[i]<a[i-1]){
         mx[mxCnt]=i-1;
         mxCnt++;
         dir=-1;
      }
   }
   
   if(dir==1){
         mx[mxCnt]=size-1;
         mxCnt++;          
   }
   else if(dir==-1){
         //mn[mnCnt]=size-1;
         //mnCnt++;       
   }
   
}

void SmoothArray(double & from[],double & to[],int period){
   int half=period/2;
   int size=ArraySize(from);   
   for(int i=0;i<size;i++){
      int f=MathMax(i-half,0);
      int t=MathMin(f+period,size);
      to[i]=0;
      for(int j=f;j<t;j++){
         to[i]+=from[j];
      }
      to[i]/=period;
   }   
}